#ifndef _LISTA_H_
#define _LISTA_H_

#include "Elemento.h"

template<class TIPO>
class Lista
{
private:
    Elemento<TIPO>*  pPrimeiro;
    Elemento<TIPO>*  pAtual;

public:

    Lista ( );
    ~Lista ( );
    void inicializa ( );
	void limpar();
    bool incluaElemento ( Elemento<TIPO>* pElemento );
    bool incluaInfo ( TIPO* pInfo );
    void listeInfos ( );
	Elemento<TIPO>* getpPrimeiro();
	Elemento<TIPO>* getpAtual();

};

template<class TIPO>
Lista<TIPO>::Lista ( )
{
    inicializa ( );
}

template<class TIPO>
Lista<TIPO>::~Lista ( )
{
	limpar();
}

template<class TIPO>
void Lista<TIPO>::inicializa ( )
{
     pPrimeiro = NULL;
     pAtual    = NULL;
}

template<class TIPO>
void Lista<TIPO>::limpar ( )
{
	 Elemento<TIPO>* paux1;
	 Elemento<TIPO>* paux2;

	 paux1 = pPrimeiro;
	 paux2 = paux1;

	 while (paux1 != NULL)
	 {
		 paux2 = paux1->getProximo();
		 //delete (paux1->getInfo())
		 delete (paux1);
		 paux1 = paux2;		 
	 }

	 pPrimeiro = NULL;
	 pAtual    = NULL;
}

template<class TIPO>
bool Lista<TIPO>::incluaElemento ( Elemento<TIPO>* pElemento )
{
    if (NULL != pElemento)
    {

       if (NULL == pPrimeiro)
       {
          pPrimeiro = pElemento;
          pPrimeiro->setAnterior ( NULL );
          pPrimeiro->setProximo ( NULL );
          pAtual = pPrimeiro;
      }
      else
      {
          pElemento->setAnterior ( pAtual );
          pElemento->setProximo ( NULL );
          pAtual->setProximo ( pElemento );
          pAtual = pAtual->getProximo ( ); 
      }
      return true;
    }
    else
    {
        cout << "Erro, elemento nulo na lista." << endl;
        return false;
    }
}

template<class TIPO>
bool Lista<TIPO>::incluaInfo ( TIPO *pInfo )
{
     if (NULL != pInfo)
     {
          Elemento<TIPO>* pElemento;
          pElemento = new Elemento<TIPO>();
          //pElemento->setNome (nome);
          pElemento->setInfo (pInfo);
          incluaElemento (pElemento);
          return true;
     }
     else
     {
          printf ( "Erro, elemento (informao) nulo(a) na lista. \n" );
          return false;
     }
}

template<class TIPO>
void Lista<TIPO>::listeInfos()
{
    Elemento<TIPO>* paux;
    paux = pPrimeiro;

    if (NULL != pPrimeiro)
    {
         while (NULL != paux)
         {
              printf ( "Elemento na lista %s \n", paux->getNome() );
              paux = paux->getProximo();
         }
    }
}
template<class TIPO>
Elemento<TIPO>* Lista<TIPO>::getpPrimeiro()
{
	return pPrimeiro;
}
template<class TIPO>
Elemento<TIPO>* Lista<TIPO>::getpAtual()
{
	return pAtual;
}

#endif
